#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

void readOutput(InStream& in, int m, vector<pair<int, int> > &res) {
    int cnt = in.readInt(0, m * (m - 1) / 2);
    for (int i = 0; i < cnt; i++) {
        int x = in.readInt(1, m);
        int y = in.readInt(1, m);
        if (x == y) {
            in.quitf(_wa, "Numbers in pair should be different");
        }
        if (x > y) {
            swap(x, y);
        }
        res.push_back({x, y});
    }
    sort(res.begin(), res.end());
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    inf.readInt();
    inf.readToken();

    int m = inf.readInt();

    vector<pair<int, int> > answer, output;

    readOutput(ans, m, answer);
    readOutput(ouf, m, output);

    if (answer != output) {
        quitf(_wa, "Participant's answer is wrong");
    }

    quitf(_ok, "ok");
}