#include <iostream>
#include <string>
#include <vector>
#include <assert.h>

using namespace std;

int main() {
    int n;
    cin >> n;
    string answers;
    cin >> answers;
    assert(answers.size() == n);
    for (int i = 0; i < n; i++) {
        assert(answers[i] >= 'A' && answers[i] <= 'D');
    }
    int m;
    cin >> m;
    string tests[m];
    for (int i = 0; i < m; i++) {
        cin >> tests[i];
        assert(tests[i].size() == n);
        for (int j = 0; j < n; j++) {
            assert(tests[i][j] >= 'A' && tests[i][j] <= 'D');
        }
    }
    int correct[m];
    for (int i = 0; i < m; i++) {
        correct[i] = 0;
        for (int j = 0; j < n; j++) {
            if (tests[i][j] == answers[j]) {
                correct[i]++;
            }
        }
    }
    vector<pair<int, int> > similar;
    for (int i = 0; i < m; i++) {
        for (int j = i + 1; j < m; j++) {
            int same_correct = 0, same_wrong = 0;
            for (int k = 0; k < n; k++) {
                if (tests[i][k] == tests[j][k]) {
                    if (tests[i][k] == answers[k]) {
                        same_correct++;
                    } else {
                        same_wrong++;
                    }
                }
            }
            if (same_correct * 2 > min(correct[i], correct[j]) &&
                same_wrong * 2 > max(n - correct[i], n - correct[j])) {
                similar.push_back({i, j});
            }
        }
    }
    cout << similar.size() << "\n";
    for (pair<int, int> it : similar) {
        cout << it.first + 1 << " " << it.second + 1 << "\n";
    }
    return 0;
}