// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>
#include "testlib.h"

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main(int argc, char** argv) {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    registerGen(argc, argv, 1);

    string tp = argv[1];
    int n = atoi(argv[2]);

    cout << n << "\n";
    if (tp == "A") {
        for (int i = 0; i < n; ++i)
            cout << 1 + i << " " << 1 + (i + 1) % n << " " << 1 + (i + 2) % n << "\n";
    } else if (tp == "B") {
        vector<int> ord;

        for (int i = 0; i < n/2; ++i) {
            ord.push_back(i);
            ord.push_back(i + (n/2));
        }

        if (n % 2)
            ord.push_back(n - 1);

        for (int i: ord)
            cout << 1 + i << " " << 1 + (i + 1) % n << " " << 1 + (i + 2) % n << "\n";
    } else if (tp == "C") {
        vector<int> ord(n, -1);
        int p = 0, q = n - 1;
        
        for (int i = 0; i < n; ++i)
            if (i % 2)
                ord[q--] = i;
            else
                ord[p++] = i;

        for (int i: ord)
            cout << 1 + i << " " << 1 + (i + 1) % n << " " << 1 + (i + 2) % n << "\n";
    }
    
    return 0;
}
