#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	int q = atoi(argv[3]);

	vector<pii> edges;

	for (int i = 1; i < n; ++i) {
		int p = rnd.wnext(i, q);
		edges.push_back({p, i});
	}

	for (int i = 0; i < k; ++i) {
		int a = rnd.next(0, n - 1);
		int b = rnd.next(0, n - 1);
		edges.push_back({a, b});
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	shuffle(order.begin(), order.end());

	shuffle(edges.begin(), edges.end());

	vector<int> outp;
	for (auto& e : edges) {
		if (rnd.next(0, 1)) {
			swap(e.ff, e.ss);
		}
		outp.push_back(order[e.ff] + 1);
		outp.push_back(order[e.ss] + 1);
	}

	cout << szof(outp) << "\n";
	for (int i = 0; i < szof(outp); ++i) {
		cout << outp[i];
		if (i < szof(outp) - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}