#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    long long s;
    cin >> n >> m >> s;

    vector<pair<int, long long>> add;
    for (unsigned int i = 0; i < n; i++) {
        long long count;
        unsigned int from, to;
        cin >> count >> from >> to;
        if (count > 0) {
            add.emplace_back(to, count);
        } else {
            add.emplace_back(from, count);
        }
    }

    sort(add.begin(), add.end(), [](auto const &l, auto const &r) {
        return l.first == r.first ? l.second < r.second : l.first < r.first;
    });

    for (auto const &op : add) {
        s += op.second;
        if (s < 0) {
            cout << "YES\n";
            return 0;
        }
    }

    cout << "NO\n";

}
