#include <bits/stdc++.h>

using namespace std;

#include "testlib.h"

int a[50], g[50], n, mod, kent;

const int C = (1 << 30) - 1, maxn = 15e6;

int q[2][maxn], sz[2];

void go(int l, int r, int t, int s) {
    if (l == r) {
        if (s < 0)
            s += mod;
        q[t][sz[t]++] = s;
        return;
    }
    for (int x = -1; x < 2; x++)
        go(l + 1, r, t, (s + x * g[l]) % mod);
}

void solve() {
    int s = 0;
    for (int i = 0; i < n; i++)
        s = (s + a[i] * g[i]) % mod;
    if (s != 0)
        quitf(_wa, "sum isn't 0");
    int m = n / 2;
    go(0, m, 0, 0);
    go(m, n, 1, 0);
    for (int i = 0; i < sz[1]; i++)
        if (q[1][i] == 0)
            q[1][i] = mod;
    for (int t = 0; t < 2; t++)
        sort(q[t], q[t] + sz[t]);
    reverse(q[1], q[1] + sz[1]);
    int w = 1, it = 0, so = 0;
    for (int i = 0; i < sz[0]; i++) {
        int o = q[0][i];
        while (it < sz[1] && o + q[1][it] > mod)
            it++, w = 1;
        while (it + 1 < sz[1] && q[1][it] == q[1][it + 1])
            it++, w++;
        if (it < sz[1] && o + q[1][it] == mod) {
            so += w;
            if (so > 3)
                quitf(_wa, "more than 3(%d) vectors exist", so);
        }
    }
    assert(so == 3);
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    for (int i = 0; i < n; i++)
        a[i] = inf.readInt();
    mod = ouf.readInt(1, C, "mod");
    if (mod >= (1 << n))
        quitf(_wa, "mod is more than 2^n");
    for (int i = 0; i < n; i++)
        g[i] = ouf.readInt(-C, C, "x_i");
    if (!ouf.seekEof())
        quitf(_pe, "more numbers than expected");
    solve();
    quitf(_ok, "%d numbers", n);
}
