#ifdef LOCAL
#include "../../testlib.h"
#else
#include "testlib.h"
#endif
#include <iostream>
#include <string>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    unsigned int pos = atoi(argv[1]), neg = atoi(argv[2]), zero = atoi(argv[3]);
    unsigned int n = pos + neg + zero, m = (1u << n) - (1u << zero);
    printf("%d %d\n", n, m);

    vector<int> sign(n, 0);
    for (unsigned int i = zero; i < n; i++) {
        sign[i] = i - zero < pos ? 1 : -1;
    }
    for (unsigned int i = zero; i < n; i++) {
        swap(sign[i], sign[rnd.next(i, n - 1)]);
    }

    vector<unsigned int> res(n);
    for (unsigned int i = 0; i < n; i++) {
        unsigned int val = 1u << i;
        if ((sign[i] < 0 || sign[i] == 0 && rnd.next(2)) && m != val) {
            val = m - val;
        }
        res[i] = val + rnd.next(0, (10'000'000 - (int) val) / (int) m) * m;
    }
    shuffle(res.begin(), res.end());
    for (unsigned int i = 0; i < n; i++) {
        if (i > 0) {
            printf(" ");
        }
        printf("%d", res[i]);
    }
    printf("\n");
}