// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 200100;
 
int a[N][3];
std::vector<int> id[N];
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    int n;
    scanf("%d", &n);
 
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 3; ++j) {
            scanf("%d", &a[i][j]);
 
            id[a[i][j]].push_back(i);
        }
    }
 
    if (n == 3) {
        printf("1 2 3\n");
        return 0;
    }
    if (n == 4) {
        printf("1 2 3 4\n");
        return 0;
    }
 
    std::map<int, int> cnt;
    for (auto i : id[1]) {
        // debug(i);
        for (int j = 0; j < 3; ++j) {
            if (a[i][j] != 1) {
                ++cnt[a[i][j]];
            }
        }
    }
 
    std::vector<int> ans;
    for (auto i : cnt) {
        if (i.second == 2) {
            ans.push_back(i.first);
        }
    }
 
    ans.push_back(1);
    std::swap(ans[1], ans[2]);
 
    // debug(ans.size());
 
    assert(ans.size() == 3);
 
    for (int it = 2; it < n; ++it) {
        cnt.clear();
 
        for (auto i : id[ans[it]]) {
            for (int j = 0; j < 3; ++j) {
                if (a[i][j] != ans[it]) {
                    ++cnt[a[i][j]];
                }
            }
        }
 
        int sh = 0;
 
        for (auto i : cnt) {
            if (i.second == 2 && i.first != ans[it - 1]) {
                ans.push_back(i.first);
                ++sh;
            }
        }
 
        assert(sh == 1);
    }
 
    for (int i = 0; i < n; ++i) {
        printf("%d ", ans[i]);
    }
    printf("\n");
 
    return 0;
}
