#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int mod = (int)1e9 + 7;

const int dd = (int)3e5 + 7;

struct FenTree {
	int T[dd];
	
	void upd(int pos, int val) {
		for (int i = pos + 1; i < dd; i += (i&-i)) T[i] += val;
	}
	int get(int pos) {
		int res = 0;
		for (int i = pos + 1; i; i -= (i&-i)) res += T[i];
		return res;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
} F;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n; cin >> n;
	vector<int> P(n), pos(n), ind(n);
	for (int i = 0; i < n; i++) {
		cin >> P[i];
		P[i]--;
		pos[P[i]] = i;
	}
	
	for (int i = 0; i < n; i++) F.upd(i, 1);
	
	auto nxt = [&](int i) { return i + 1 == n ? 0 : i + 1; };
	auto get_ind = [&](int st, int i) {
		if (st <= i) return F.get(st, i) - 1;
		return F.get(st, n) + F.get(0, i) - 1;
	};
	
	ind[n - 1] = pos[n - 1];
	for (int x = n - 2; x >= 0; x--) {
		int st = nxt(pos[x + 1]);
		F.upd(pos[x + 1], -1);
		ind[x] = get_ind(st, pos[x]);
	}
	
	int cnt_n = 0, ans = 0;
	for (int x = 1; x < n; x++) {
		cnt_n = (1ll * cnt_n * x + x - 1 - ind[x - 1]) % mod;
		ans = (ans + 1ll * (x + 1) * cnt_n + x - ind[x]) % mod;
	}
	cout << (ans + 1) % mod << "\n";
	return 0;
}