#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t = atoi(argv[1]);
	int maxm = atoi(argv[2]);
	int maxn = atoi(argv[3]);

	vector<int> outp;
	vector<int> dsu(maxn);
	vector<int> sz(maxn);
	iota(dsu.begin(), dsu.end(), 0);
	vector<pair<int*, int>> changes;

	auto get_root = [&](int v) {
		while (dsu[v] != v) {
			v = dsu[v];
		}
		return v;
	};

	auto unite = [&](int a, int b) {
		int ra = get_root(a);
		int rb = get_root(b);
		if (ra == rb) {
			return false;
		}
		if (sz[ra] > sz[rb]) {
			swap(ra, rb);
		}
		changes.push_back({&dsu[ra], dsu[ra]});
		dsu[ra] = rb;
		if (sz[ra] == sz[rb]) {
			changes.push_back({&sz[rb], sz[rb]});
			++sz[rb];
		}
		return true;
	};

	for (int i = 0; i < t; ++i) {
		int m = rnd.next(0, min(maxm, maxn - 1));
		outp.push_back(m);
		for (int j = 0; j < m; ++j) {
			while (true) {
				int a = rnd.next(0, maxn - 1);
				int b = rnd.next(0, maxn - 1);
				if (unite(a, b)) {
					outp.push_back(a);
					outp.push_back(b);
					break;
				}
			}
		}
		while (szof(changes)) {
			*changes.back().ff = changes.back().ss;
			changes.pop_back();
		}
	}

	cout << szof(outp) << "\n";
	for (int i = 0; i < szof(outp); ++i) {
		cout << outp[i];
		if (i < szof(outp) - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}